﻿using System.ComponentModel.DataAnnotations;
using Connected.Annotations;
using Connected.Data;
using Connected.ServiceModel;

namespace Connected.Common.Types.BankAccounts;

public class BankAccountInsertArgs : Dto
{
	[MinValue(1)]
	public int Bank { get; set; }

	[Required]
	[MaxLength(128)]
	public string? Iban { get; set; }

	[Required]
	[MaxLength(128)]
	public string? Type { get; set; }

	[Required]
	[MaxLength(128)]
	public string? PrimaryKey { get; set; }

	public Status Status { get; set; } = Status.Enabled;
}

public sealed class BankAccountUpdateArgs : BankAccountInsertArgs
{
	[MinValue(1)]
	public int Id { get; set; }
}
