﻿using System.Collections.Immutable;
using Connected.Annotations;
using Connected.Notifications;
using Connected.ServiceModel;

namespace Connected.Common.Types.BankAccounts;

[Service]
[ServiceUrl(Routes.BankAccounts)]
public interface IBankAccountService : IServiceNotifications<int>
{
	[ServiceMethod(ServiceMethodVerbs.Get)]
	Task<ImmutableList<IBankAccount>?> Query();

	[ServiceMethod(ServiceMethodVerbs.Get | ServiceMethodVerbs.Post)]
	Task<ImmutableList<IBankAccount>?> Query(PrimaryKeyArgs<int> args);

	[ServiceMethod(ServiceMethodVerbs.Get | ServiceMethodVerbs.Post)]
	Task<ImmutableList<IBankAccount>?> Query(PrimaryKeyListArgs<int> args);

	[ServiceMethod(ServiceMethodVerbs.Get | ServiceMethodVerbs.Post)]
	Task<IBankAccount?> Select(PrimaryKeyArgs<int> args);

	[ServiceMethod(ServiceMethodVerbs.Post | ServiceMethodVerbs.Delete)]
	Task Delete(PrimaryKeyArgs<int> args);

	[ServiceMethod(ServiceMethodVerbs.Post | ServiceMethodVerbs.Put)]
	Task<int> Insert(BankAccountInsertArgs args);

	[ServiceMethod(ServiceMethodVerbs.Post | ServiceMethodVerbs.Put | ServiceMethodVerbs.Patch)]
	Task Update(BankAccountUpdateArgs args);
}
