﻿using System.ComponentModel.DataAnnotations;
using Connected.Annotations;
using Connected.Data;
using Connected.ServiceModel;

namespace Connected.Common.Types.Banks;

public class InsertBankArgs : Dto
{
	[Required]
	[MaxLength(128)]
	public string? Name { get; set; }

	[MinValue(1)]
	public int Country { get; set; }

	[Required]
	[MaxLength(128)]
	public string? Bic { get; set; }

	public Status Status { get; set; } = Status.Enabled;
}

public class UpdateBankArgs : InsertBankArgs
{
	[MinValue(1)]
	public int Id { get; set; }
}