﻿using System.Collections.Immutable;
using Connected.Annotations;
using Connected.Notifications;
using Connected.ServiceModel;

namespace Connected.Common.Types.Continent;

[Service]
[ServiceUrl(Routes.Continents)]
public interface IContinentService : IServiceNotifications<int>
{
	[ServiceMethod(ServiceMethodVerbs.Get)]
	Task<ImmutableList<IContinent>?> Query();

	[ServiceMethod(ServiceMethodVerbs.Get | ServiceMethodVerbs.Post)]
	Task<ImmutableList<IContinent>> Query(PrimaryKeyListArgs<int> args);

	[ServiceMethod(ServiceMethodVerbs.Get | ServiceMethodVerbs.Post)]
	Task<IContinent> Select(PrimaryKeyArgs<int> args);

	[ServiceMethod(ServiceMethodVerbs.Put | ServiceMethodVerbs.Post)]
	Task<int> Insert(InsertContinentArgs args);

	[ServiceMethod(ServiceMethodVerbs.Put | ServiceMethodVerbs.Post | ServiceMethodVerbs.Patch)]
	Task Update(UpdateContitentArgs args);

	[ServiceMethod(ServiceMethodVerbs.Delete | ServiceMethodVerbs.Post)]
	Task Delete(PrimaryKeyArgs<int> args);
}
