﻿using System.ComponentModel.DataAnnotations;
using Connected.Annotations;
using Connected.Data;
using Connected.ServiceModel;

namespace Connected.Common.Types.Countries;

public class InsertCountryArgs : Dto
{
	[Required]
	[MaxLength(128)]
	public string Name { get; set; }

	[MinValue(0)]
	public int Lcid { get; set; }

	[MaxLength(128)]
	public string? IsoCode { get; set; }

	public Status Status { get; set; } = Status.Enabled;
}

public class UpdateCountryArgs : InsertCountryArgs
{
	[MinValue(1)]
	public int Id { get; set; }
}
