﻿using System.Collections.Immutable;
using Connected.Annotations;
using Connected.Notifications;
using Connected.ServiceModel;

namespace Connected.Common.Types.Countries;

[Service]
[ServiceUrl(Routes.Countries)]

public interface ICountryService : IServiceNotifications<int>
{
	[ServiceMethod(ServiceMethodVerbs.Get)]
	Task<ImmutableList<ICountry>?> Query();

	[ServiceMethod(ServiceMethodVerbs.Get | ServiceMethodVerbs.Post)]
	Task<ImmutableList<ICountry>?> Query(PrimaryKeyListArgs<int> args);

	[ServiceMethod(ServiceMethodVerbs.Get | ServiceMethodVerbs.Post)]
	Task<ICountry?> Select(PrimaryKeyArgs<int> args);

	[ServiceMethod(ServiceMethodVerbs.Get | ServiceMethodVerbs.Post)]
	Task<ICountry?> Select(NameArgs args);

	[ServiceMethod(ServiceMethodVerbs.Delete | ServiceMethodVerbs.Post)]
	Task Delete(PrimaryKeyArgs<int> args);

	[ServiceMethod(ServiceMethodVerbs.Put | ServiceMethodVerbs.Post)]
	Task<int> Insert(InsertCountryArgs args);

	[ServiceMethod(ServiceMethodVerbs.Put | ServiceMethodVerbs.Post | ServiceMethodVerbs.Patch)]
	Task Update(UpdateCountryArgs args);
}
