﻿using System.ComponentModel.DataAnnotations;
using Connected.Annotations;
using Connected.Data;
using Connected.ServiceModel;

namespace Connected.Common.Types.Currencies;

public class CurrencyInsertArgs : Dto
{
	[Required]
	[MaxLength(128)]
	public string? Name { get; set; }

	[Required]
	[MaxLength(32)]
	public string? Code { get; set; }

	[Required]
	[MaxLength(8)]
	public string? Symbol { get; set; }

	[MinValue(0)]
	public int Lcid { get; set; }

	public Status Status { get; set; } = Status.Enabled;
}

public sealed class CurrencyUpdateArgs : CurrencyInsertArgs
{
	[MinValue(1)]
	public int Id { get; set; }
}

public sealed class CurrencyFormatArgs : Dto
{
	[Range(0, int.MaxValue)]
	public int Currency { get; set; }

	public double Value { get; set; }
}
