﻿using System.Collections.Immutable;
using Connected.Annotations;
using Connected.Notifications;
using Connected.ServiceModel;

namespace Connected.Common.Types.MeasureUnits;

[Service]
[ServiceUrl(Routes.MeasureUnits)]
public interface IMeasureUnitService : IServiceNotifications<int>
{
	[ServiceMethod(ServiceMethodVerbs.Get)]
	Task<ImmutableList<IMeasureUnit>?> Query();

	[ServiceMethod(ServiceMethodVerbs.Get | ServiceMethodVerbs.Post)]
	Task<ImmutableList<IMeasureUnit>?> Query(PrimaryKeyListArgs<int> args);

	[ServiceMethod(ServiceMethodVerbs.Get | ServiceMethodVerbs.Post)]
	Task<IMeasureUnit?> Select(PrimaryKeyArgs<int> args);

	[ServiceMethod(ServiceMethodVerbs.Post | ServiceMethodVerbs.Delete)]
	Task Delete(PrimaryKeyArgs<int> args);

	[ServiceMethod(ServiceMethodVerbs.Post | ServiceMethodVerbs.Put)]
	Task<int> Insert(MeasureUnitInsertArgs args);

	[ServiceMethod(ServiceMethodVerbs.Post | ServiceMethodVerbs.Put | ServiceMethodVerbs.Patch)]
	Task Update(MeasureUnitUpdateArgs args);
}
