﻿using System.ComponentModel.DataAnnotations;
using Connected.Data;
using Connected.ServiceModel;

namespace Connected.Common.Types.MeasureUnits;

public class MeasureUnitInsertArgs : Dto
{
	[Required]
	[MaxLength(128)]
	public string? Name { get; set; }

	[Required]
	[MaxLength(8)]
	public string? Code { get; set; }

	[Range(0, 32)]
	public byte Precision { get; set; }

	public Status Status { get; set; } = Status.Enabled;
}

public sealed class MeasureUnitUpdateArgs : MeasureUnitInsertArgs
{
	[Range(1, int.MaxValue)]
	public int Id { get; set; }
}
