﻿using System.ComponentModel.DataAnnotations;
using Connected.Annotations;
using Connected.Data;
using Connected.ServiceModel;

namespace Connected.Common.Types.PostalCodes;

public class PostalCodeInsertArgs : Dto
{
	[MinValue(1)]
	public int Country { get; set; }

	[Required]
	[MaxLength(128)]
	public string? Name { get; set; }

	[Required]
	[MaxLength(16)]
	public string? Code { get; set; }

	public Status Status { get; set; } = Status.Enabled;
}

public sealed class PostalCodeUpdateArgs : PostalCodeInsertArgs
{
	[Range(1, int.MaxValue)]
	public int Id { get; set; }
}

public sealed class PostalCodeSearchArgs : Dto
{
	[Range(0, int.MaxValue)]
	public int Country { get; set; }

	[MaxLength(128)]
	public string? Name { get; set; }

	[MaxLength(16)]
	public string? Code { get; set; }
}
