﻿using Connected.Components;
using Microsoft.AspNetCore.Components;

namespace Connected.Common.Types.TaxRates.Components;

public partial class TaxRateAdd : UIComposition
{
	public TaxRateAdd()
	{
		DataSource = new InsertTaxRateArgs();
	}

	private InsertTaxRateArgs DataSource { get; }

	[Inject]
	private ITaxRateService? TaxRateService { get; set; }

	[Inject]
	private NavigationManager? Navigation { get; set; }

	protected override async Task OnParametersSetAsync()
	{
		if (TaxRateService is null)
			throw new ArgumentException(null, nameof(TaxRateService));

		await base.OnParametersSetAsync();
	}
	protected virtual async void OnInsert()
	{
		await TaxRateService.Insert(DataSource);

		Navigation.NavigateTo(Routes.TaxRates);
	}

	protected virtual void OnCancel()
	{
		Navigation.NavigateTo(Routes.TaxRates);
	}
}