﻿using Connected.Components;
using Connected.ServiceModel;
using Microsoft.AspNetCore.Components;

namespace Connected.Common.Types.TaxRates.Components;

public partial class TaxRateEdit : UIComposition
{
	[Parameter]
	public int Id { get; set; }
	private UpdateTaxRateArgs? DataSource { get; set; }

	[Inject]
	private ITaxRateService? TaxRateService { get; set; }

	[Inject]
	private NavigationManager? Navigation { get; set; }

	protected override async Task OnParametersSetAsync()
	{
		var taxRate = await TaxRateService.Select(new PrimaryKeyArgs<int> { Id = Convert.ToInt32(Id) });

		DataSource = new UpdateTaxRateArgs
		{
			Id = taxRate.Id,
			Name = taxRate.Name,
			Rate = taxRate.Rate
		};
	}

	private async void OnUpdate()
	{
		await TaxRateService.Update(DataSource);

		Navigation.NavigateTo(CommonTypesUIRoutes.TaxRates);
	}

	private void OnCancel()
	{
		Navigation.NavigateTo(CommonTypesUIRoutes.TaxRates);
	}
}
