﻿using Connected.Common.Types.Continent;
using Connected.Common.Types.Countries;
using Connected.Data.DataProtection;
using Connected.Data.EntityProtection;
using Connected.Entities;
using Connected.Middleware;
using Connected.Validation;

namespace Connected.Common.Types.Continents.Countries;

internal class ContinentProtector : MiddlewareComponent, IEntityProtector<IContinent>
{
	public ContinentProtector(IContinentCountryCache cache)
	{
		Cache = cache;
	}

	private IContinentCountryCache Cache { get; }

	public async Task Invoke(EntityProtectionArgs<IContinent> args)
	{
		if ((await (from dc in Cache where dc.Continent == args.Entity.Id select dc).AsEntity()) is not null)
			throw ValidationExceptions.ReferenceExists(typeof(ICountry), args.Entity.Id);
	}
}
