﻿using Connected.Data;
using Connected.Entities.Annotations;
using Connected.Entities.Consistency;

namespace Connected.Common.Types.Countries;

[Table(Schema = SchemaAttribute.TypesSchema)]
internal record Country : ConsistentEntity<int>, ICountry
{
	public const string CacheKey = $"{SchemaAttribute.TypesSchema}.{nameof(Country)}";

	[Length(128)]
	public string Name { get; init; }

	public int Lcid { get; init; }

	[Length(128)]
	public string IsoCode { get; init; }


	public Status Status { get; init; } = Status.Enabled;
}
