﻿using Connected.Common.Types.TaxRates;
using Connected.Entities;

namespace Common.Types.TaxRates.Ops;

internal class TaxRateSamples
{
	internal static IEnumerable<TaxRate> GetEmptyTaxRateSet() => new List<TaxRate> { };

	internal static IEnumerable<TaxRate> GetTaxRates(State state) => CombinedTaxRateSet.Where(e => e.State == state);

	public static TaxRate NewEnabled = new()
	{
		Id = 1,
		Name = nameof(NewEnabled),
		Rate = 10,
		State = State.New,
		Status = Connected.Data.Status.Enabled
	};

	public static TaxRate NotModifiedEnabled = new()
	{
		Id = 3,
		Name = nameof(NotModifiedEnabled),
		Rate = 30,
		State = State.Default,
		Status = Connected.Data.Status.Enabled
	};

	public static TaxRate DeletedEnabled = new()
	{
		Id = 4,
		Name = nameof(DeletedEnabled),
		Rate = 40,
		State = State.Deleted,
		Status = Connected.Data.Status.Enabled
	};

	public static TaxRate NewDisabled = new()
	{
		Id = 5,
		Name = nameof(NewDisabled),
		Rate = 50,
		State = State.New,
		Status = Connected.Data.Status.Disabled
	};

	public static TaxRate NotModifiedDisabled = new()
	{
		Id = 7,
		Name = nameof(NotModifiedDisabled),
		Rate = 70,
		State = State.Default,
		Status = Connected.Data.Status.Disabled
	};

	public static TaxRate DeletedDisabled = new()
	{
		Id = 8,
		Name = nameof(DeletedDisabled),
		Rate = 80,
		State = State.Deleted,
		Status = Connected.Data.Status.Disabled
	};

	internal static IEnumerable<TaxRate> CombinedTaxRateSet => new List<TaxRate>
	{
		NewEnabled,
		NotModifiedEnabled,
		DeletedEnabled,
		NewDisabled,
		NotModifiedDisabled,
		DeletedDisabled
	};
}
